#include <Carbon/Carbon.r>

#define Reserved8   reserved, reserved, reserved, reserved, reserved, reserved, reserved, reserved
#define Reserved12  Reserved8, reserved, reserved, reserved, reserved
#define Reserved13  Reserved12, reserved
#define dp_none__   noParams, "", directParamOptional, singleItem, notEnumerated, Reserved13
#define reply_none__   noReply, "", replyOptional, singleItem, notEnumerated, Reserved13
#define synonym_verb__ reply_none__, dp_none__, { }
#define plural__    "", {"", kAESpecialClassProperties, cType, "", reserved, singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural}, {}

resource 'aete' (0, "FastScripts") {
	0x1,  // major version
	0x0,  // minor version
	english,
	roman,
	{
		"Type Names Suite",
		"Hidden terms",
		kASTypeNamesSuite,
		1,
		1,
		{
			/* Events */

		},
		{
			/* Classes */

			"application", 'capp',
			"The application's top-level scripting object.",
			{
				"fastscripts menu icon", 'Menu', 'mBar',
				"Represents the FastScripts menu bar item installed in the upper-right corner of the screen.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},

			"menu bar icon", 'mBar',
			"Represents the FastScripts menu bar item installed in the upper-right corner of the screen.",
			{
				"visible", 'pvis', 'bool',
				"Is the FastScripts menu bar item visible? If set to false, FastScripts behaves as usual, but can only be accessed by keyboard shortcut or through scripted control.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"menu bar icon", 'mBar', plural__,

			"file or list of file", 't000', "", { }, { },

			"list of file or specifier", '****', "", { }, { }
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
		},

		"FastScripts Suite",
		"Classes and commands relating to FastScripts and its ability to manage a collection of script items.",
		'FsXX',
		1,
		1,
		{
			/* Events */

			"invoke",
			"Invoke a script item in a manner identical to the user selecting the item by menu or keyboard shortcut. WARNING: Exercise caution when using this command from within a script executed by FastScripts as recursive cycle may occur.",
			'fsXX', 'fsIN',
			reply_none__,
			'sITm',
			"the script item to be invoked",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			}
		},
		{
			/* Classes */

			"application", 'capp',
			"The application's top-level scripting object.",
			{
				"name", 'pnam', 'TEXT',
				"The name of the application.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"frontmost", 'pisf', 'bool',
				"Is this the frontmost (active) application?",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"version", 'vers', 'TEXT',
				"The version of the application.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
				'cwin', { },
				'tScr', { },
				'sITm', { }
			},
			"applications", 'capp', plural__,

			"script library", 'sLiB',
			"A hierarchical collection of script items.",
			{
				"name", 'pnam', 'TEXT',
				"The script library's name.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"parent library", 'pLib', 'sLiB',
				"The script library in which this item is hierarchically contained.  This property is undefined for top level script libraries.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
				'sLiB', { },
				'sITm', { }
			},
			"script libraries", 'sLiB', plural__,

			"script item", 'sITm',
			"A reference to a user-invokable script, application, or document.",
			{
				"name", 'pnam', 'TEXT',
				"The script item's name.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"parent library", 'pLib', 'sLiB',
				"The script library in which this item is hierarchically contained.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"script file", 'sFil', 'file',
				"If this script item was loaded from a file on disk, this is a reference to that file.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"has keyboard shortcut", 'hKey', 'bool',
				"True if this script item is assigned a keyboard shortcut",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"keyboard shortcut", 'kCut', 'kCOM',
				"The key combination assigned as the shortcut for this script, if any.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"script items", 'sITm', plural__,

			"top level script library", 'tScr',
			"a script library that is not contained by any other script library and which therefore possesses certain magical qualities",
			{
				"<Inheritance>", pInherits, 'sLiB',
				"inherits elements and properties of the script library class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"top level script libraries", 'tScr', plural__,

			"key combination", 'kCOM',
			"A description of a combination of characters, such as you might use for a keyboard shortcut.",
			{
				"shortcut string", 'KVal', 'TEXT',
				"A unicode representation of the modifier keys and keyboard character that comprise this combination.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"key combinations", 'kCOM', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
		},

		"FastScripts UI Suite",
		"Commands used to communicate information to the user.",
		'FsUI',
		1,
		1,
		{
			/* Events */

			"display message",
			"Display a self-dismissing message at a specificed location on the screen.",
			'FsUI', 'Dmsg',
			'mWin',
			"the window used to display the message",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'TEXT',
			"the message text to display",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"dismissing after delay", 'Dlay', 'doub',
				"time in seconds to display before auto-dismissing, if zero then never auto-dismiss, defaults to 1 second",
				optional,
				singleItem, notEnumerated, Reserved13,
				"at screen position", 'aPos', 'sPos',
				"the location on the main screen at which the message will appear, defaults to center",
				optional,
				singleItem, enumerated, Reserved13
			}
		},
		{
			/* Classes */

			"message window", 'mWin',
			"A self dismissing window suitable for unobtrusively displaying a message on the screen.",
			{
				"<Inheritance>", pInherits, 'cwin',
				"inherits elements and properties of the window class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"autodismiss time", 'Adis', 'doub',
				"time in seconds before the window will auto-dismiss",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"screen position", 'sPos', 'sPos',
				"the location on the screen at which the message should appear",
				reserved, singleItem, enumerated, readWrite, Reserved12
			},
			{
			},
			"message windows", 'mWin', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
			'sPos',
			{
				"top left", 'tLft', "Positioned near the top-left corner of the screen.",
				"top center", 'tCtr', "Positioned near the top-center of the screen.",
				"top right", 'tRte', "Positioned near the top-right corner of the screen.",
				"center", 'cNtr', "Positioned near the center of the screen.",
				"bottom left", 'bLft', "Positioned near the bottom-left corner of the screen.",
				"bottom right", 'bRte', "Positioned near the bottom-right corner of the screen.",
				"bottom center", 'bCtr', "Positioned near the bottom-center of the screen."
			}
		},

		"Text Suite",
		"A set of basic classes for text processing.",
		'TEXT',
		1,
		1,
		{
			/* Events */

		},
		{
			/* Classes */

			"color", 'cRGB',
			"",
			{
			},
			{
			},

			"rich text", 'ctxt',
			"Rich (styled) text",
			{
				"color", 'colr', 'cRGB',
				"The color of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"font", 'font', 'TEXT',
				"The name of the font of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"size", 'ptsz', 'long',
				"The size in points of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'cha ', { },
				'cpar', { },
				'cwor', { },
				'catr', { },
				'atts', { }
			},
			"rich text", 'ctxt', plural__,

			"character", 'cha ',
			"This subdivides the text into characters.",
			{
				"color", 'colr', 'cRGB',
				"The color of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"font", 'font', 'TEXT',
				"The name of the font of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"size", 'ptsz', 'long',
				"The size in points of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'cha ', { },
				'cpar', { },
				'cwor', { },
				'catr', { },
				'atts', { }
			},
			"characters", 'cha ', plural__,

			"paragraph", 'cpar',
			"This subdivides the text into paragraphs.",
			{
				"color", 'colr', 'cRGB',
				"The color of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"font", 'font', 'TEXT',
				"The name of the font of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"size", 'ptsz', 'long',
				"The size in points of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'cha ', { },
				'cpar', { },
				'cwor', { },
				'catr', { },
				'atts', { }
			},
			"paragraphs", 'cpar', plural__,

			"word", 'cwor',
			"This subdivides the text into words.",
			{
				"color", 'colr', 'cRGB',
				"The color of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"font", 'font', 'TEXT',
				"The name of the font of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"size", 'ptsz', 'long',
				"The size in points of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'cha ', { },
				'cpar', { },
				'cwor', { },
				'catr', { },
				'atts', { }
			},
			"words", 'cwor', plural__,

			"attribute run", 'catr',
			"This subdivides the text into chunks that all have the same attributes.",
			{
				"color", 'colr', 'cRGB',
				"The color of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"font", 'font', 'TEXT',
				"The name of the font of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"size", 'ptsz', 'long',
				"The size in points of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'cha ', { },
				'cpar', { },
				'cwor', { },
				'catr', { },
				'atts', { }
			},
			"attribute runs", 'catr', plural__,

			"attachment", 'atts',
			"Represents an inline text attachment. This class is used mainly for make commands.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the rich text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"file name", 'atfn', 'TEXT',
				"The path to the file for the attachment",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"attachments", 'atts', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
		},

		"Standard Suite",
		"Common classes and commands for all applications.",
		'core',
		1,
		1,
		{
			/* Events */

			"open",
			"Open a document.",
			'aevt', 'odoc',
			reply_none__,
			't000',
			"The file(s) to be opened.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"close",
			"Close a document.",
			'core', 'clos',
			reply_none__,
			'obj ',
			"the document(s) or window(s) to close.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"saving", 'savo', 'savo',
				"Whether or not changes should be saved before closing.",
				optional,
				singleItem, enumerated, Reserved13,
				"saving in", 'kfil', 'file',
				"The file in which to save the document.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"save",
			"Save a document.",
			'core', 'save',
			reply_none__,
			'obj ',
			"The document(s) or window(s) to save.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"in", 'kfil', 'file',
				"The file in which to save the document.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"as", 'fltp', 'TEXT',
				"The type of file to save.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"print",
			"Print a document.",
			'aevt', 'pdoc',
			reply_none__,
			'****',
			"The file(s), document(s), or window(s) to be printed.",
			directParamRequired,
			listOfItems, notEnumerated, Reserved13,
			{
				"with properties", 'prdt', 'pset',
				"The print settings to use.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"print dialog", 'pdlg', 'bool',
				"Should the application show the print dialog?",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"quit",
			"Quit the application.",
			'aevt', 'quit',
			reply_none__,
			dp_none__,
			{
				"saving", 'savo', 'savo',
				"Whether or not changed documents should be saved before closing.",
				optional,
				singleItem, enumerated, Reserved13
			},

			"count",
			"Return the number of elements of a particular class within an object.",
			'core', 'cnte',
			'long',
			"the number of elements",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"the object whose elements are to be counted",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"each", 'kocl', 'type',
				"The class of objects to be counted.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"delete",
			"Delete an object.",
			'core', 'delo',
			reply_none__,
			'obj ',
			"the object to delete",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"duplicate",
			"Copy object(s) and put the copies at a new location.",
			'core', 'clon',
			'obj ',
			"the duplicated object(s)",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"the object(s) to duplicate",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'insh', 'insl',
				"The location for the new object(s).",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with properties", 'prdt', 'reco',
				"Properties to be set in the new duplicated object(s).",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"exists",
			"Verify if an object exists.",
			'core', 'doex',
			'bool',
			"true if it exists, false if not",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'****',
			"the object in question",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"make",
			"Make a new object.",
			'core', 'crel',
			'obj ',
			"to the new object",
			replyRequired, singleItem, notEnumerated, Reserved13,
			dp_none__,
			{
				"new", 'kocl', 'type',
				"The class of the new object.",
				required,
				singleItem, notEnumerated, Reserved13,
				"at", 'insh', 'insl',
				"The location at which to insert the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with data", 'data', '****',
				"The initial contents of the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with properties", 'prdt', 'reco',
				"The initial values for properties of the object.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"move",
			"Move object(s) to a new location.",
			'core', 'move',
			'obj ',
			"the moved object(s)",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"the object(s) to move",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'insh', 'insl',
				"The new location for the object(s).",
				required,
				singleItem, notEnumerated, Reserved13
			}
		},
		{
			/* Classes */

			"print settings", 'pset',
			"",
			{
				"copies", 'lwcp', 'long',
				"the number of copies of a document to be printed",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"collating", 'lwcl', 'bool',
				"Should printed copies be collated?",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"starting page", 'lwfp', 'long',
				"the first page of the document to be printed",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"ending page", 'lwlp', 'long',
				"the last page of the document to be printed",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"pages across", 'lwla', 'long',
				"number of logical pages laid across a physical page",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"pages down", 'lwld', 'long',
				"number of logical pages laid out down a physical page",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"error handling", 'lweh', 'enum',
				"how errors are handled",
				reserved, singleItem, enumerated, readWrite, Reserved12,

				"fax number", 'faxn', 'TEXT',
				"for fax number",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"target printer", 'trpr', 'TEXT',
				"for target printer",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},

			"window", 'cwin',
			"A window.",
			{
				"name", 'pnam', 'TEXT',
				"The full title of the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"id", 'ID  ', 'long',
				"The unique identifier of the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"index", 'pidx', 'long',
				"The index of the window, ordered front to back.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"bounds", 'pbnd', 'qdrt',
				"The bounding rectangle of the window.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"closeable", 'hclb', 'bool',
				"Whether the window has a close box.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"minimizable", 'ismn', 'bool',
				"Whether the window can be minimized.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"minimized", 'pmnd', 'bool',
				"Whether the window is currently minimized.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"resizable", 'prsz', 'bool',
				"Whether the window can be resized.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"visible", 'pvis', 'bool',
				"Whether the window is currently visible.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"zoomable", 'iszm', 'bool',
				"Whether the window can be zoomed.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"zoomed", 'pzum', 'bool',
				"Whether the window is currently zoomed.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"windows", 'cwin', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
			'savo',
			{
				"yes", 'yes ', "Save the file.",
				"no", 'no  ', "Do not save the file.",
				"ask", 'ask ', "Ask the user whether or not to save the file."
			},

			'enum',
			{
				"standard", 'lwst', "Standard PostScript error handling",
				"detailed", 'lwdt', "print a detailed report of PostScript errors"
			}
		}
	}
};
